<?php

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

if (!defined('DS')) {
    define('DS', DIRECTORY_SEPARATOR);
}

require_once(dirname(__file__) . '/sphinxSearchContent.lib.php');
require_once(JPATH_SITE.DS.'components'.DS.'com_sphinxsearch'.DS.'sphinxapi.php');
require_once(JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php');
require_once(JPATH_SITE.DS.'administrator'.DS.'components'.DS.'com_search'.DS.'helpers'.DS.'search.php');

class plgSearchSphinxContent  extends JPlugin {
    
    /**
     * Constructor
     *
     * @access      protected
     * @param       object  $subject The object to observe
     * @param       array   $config  An array that holds the plugin configuration
     */
    public function __construct(&$subject, $config)
    {
        parent::__construct($subject, $config);
        $this->loadLanguage();
    }
    
    /**
     * @return array An array of search areas
     */
    public function onContentSearchAreas()
    {
        static $areas = array(
            'content' => 'Articles'
        );
        return $areas;
    }
    
    /**
     * Content Search method
     *
     * @param string Target search string
     * @param string matching option, exact|any|all
     * @param string ordering option, newest|oldest|popular|alpha|category
     */
    public function onContentSearch($text, $phrase='', $ordering='', $areas=null)
    {
        $plugin		  =& JPluginHelper::getPlugin('search', 'sphinxContent');
        $pluginParams = new JRegistry($plugin->params);

        $pServer = $pluginParams->get( 'server', 'localhost' );
        $pPort   = (int) $pluginParams->get( 'port', 3312 );
        $pIndex  = $pluginParams->get( 'index' );
        $limit   = isset($_REQUEST['limit']) ? (int) $_REQUEST['limit'] : 50 ;
        if (0 === $limit) {
    	    $limit = 1000;
        }
        
        $searchText = $text;
        if (is_array( $areas )) {
            if (!array_intersect( $areas, array_keys( $this->onContentSearchAreas() ) )) {
                return array();
	        }
        }

        // clean up our search text
        $text = trim( $text );
        if ($text == '') {
            return array();
        }

        $sphinxPlugin = new SphinxSearchContent($pServer, $pPort, $pIndex);
        $sphinxPlugin->setMatchMode($phrase);
        $sphinxPlugin->setOrder($ordering);
        $sphinxPlugin->setLimit(0, $limit);
        
        $sphinxPlugin->search($text);

        $results = $sphinxPlugin->getResults();

        // return results back to Joomla
        return $results;
    }
    
}