<?php

if (!class_exists('SphinxSearch')) {
    require_once(dirname(__file__) . '/sphinxSearch.lib.php');
}

class SphinxSearchCategories extends SphinxSearch
{
    function getResults()
    {
        $db      =& JFactory::getDBO();
        $user    =& JFactory::getUser();
        $userAid = $aid = max($user->getAuthorisedViewLevels());

        $ids = $this->getIds();

        $results = array();
        if (!empty($ids)) {

            $query = 'SELECT a.title, a.description as text, "" as created, a.alias, '
                . ' "2" AS browsernav,'
                . ' a.id AS catid,'
                . ' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug'
                . ' FROM #__categories AS a'
                . ' WHERE a.id in ( ' . implode(', ',$ids) . ')'
                . ' AND a.published = 1'
                . ' AND a.access <= '.(int) $userAid
                . ' GROUP BY a.id'
                . " ORDER BY FIELD(a.id, ". implode(', ', $ids) . ")";

            $db->setQuery($query);
            $results = $db->loadObjectList();

            if (empty ($results)){
                return array();
            }

            // get the actual links from Joomla (maintains clean urls but is probably quite slow)
            foreach($results as $key => $item) {
                $results[$key]->href = ContentHelperRoute::getCategoryRoute($item->slug, $item->secid);
                $results[$key]->section  = JText::_( 'Category' );
                $texts[] = strip_tags($results[$key]->text);
            }
            $textSnippets = $this->_sphinx->BuildExcerpts($texts, $this->_index, $this->_query, array("before_match" => '', "after_match" => ''));

            //load snippets
            $counter = 0;
            foreach($results as $key => $item) {
                $results[$key]->text = $textSnippets[$counter++];
            }
	}
        return $results;
    }
}