<?php
if (!class_exists('SphinxSearch')) {
    require_once(dirname(__file__) . '/sphinxSearch.lib.php');
}

class SphinxSearchContent extends SphinxSearch
{
    function getResults()
    {
        $db      =& JFactory::getDBO();
        $user    =& JFactory::getUser();
        $userAid = $aid = max($user->getAuthorisedViewLevels());

        $ids = $this->getIds();

        $results = array();
        if (!empty($ids)) {
            $query = 'SELECT a.id, a.title AS title, a.metadesc, a.metakey, a.created AS created, '
		. ' CONCAT(a.introtext, a.fulltext) AS text,'
                . ' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'
                . ' CASE WHEN CHAR_LENGTH(b.alias) THEN CONCAT_WS(":", b.id, b.alias) ELSE b.id END as catslug,'
                . ' "2" AS browsernav'
		. ' FROM #__content AS a'
                . ' LEFT JOIN #__categories AS b ON b.id=a.catid'
		. ' WHERE a.id in ( ' . implode(', ',$ids) . ')'
                . ' AND a.access <= '.(int) $userAid
                . ' AND IF(b.id, b.access <= '.(int) $userAid . ', 1) '
                . ' GROUP BY a.id'
		. " ORDER BY FIELD(a.id, ". implode(', ', $ids) . ")"
            ;

            $db->setQuery($query);
            $results = $db->loadObjectList();

            if (empty ($results)){
                return array();
            }

            // get the actual links from Joomla (maintains clean urls but is probably quite slow)
            foreach($results as $key => $item) {
				if ( empty($item->sectionid) ) {
					$results[$key]->href = ContentHelperRoute::getArticleRoute($item->slug, $item->catslug);
                } else {
                    $results[$key]->href = ContentHelperRoute::getArticleRoute($item->slug, $item->catslug, $item->sectionid);
                }				
                //get text for build snippets
                $texts[] = strip_tags($results[$key]->text);
            }
            $textSnippets = $this->_sphinx->BuildExcerpts($texts, $this->_index, $this->_query, array("before_match" => '<b>', "after_match" => '</b>'));
            
            //load snippets
            $counter = 0;
            foreach($results as $key => $item) {
                $results[$key]->text = $textSnippets[$counter++];
            }
        }
        
        return $results;
    }
}