<?php

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

if (!defined('DS')) {
    define('DS', DIRECTORY_SEPARATOR);
}

require_once(dirname(__file__) . '/sphinxSearchWeblinks.lib.php');
require_once(JPATH_SITE.DS.'components'.DS.'com_sphinxsearch'.DS.'sphinxapi.php');
require_once(JPATH_SITE.DS.'components'.DS.'com_weblinks'.DS.'helpers'.DS.'route.php');
require_once(JPATH_SITE.DS.'administrator'.DS.'components'.DS.'com_search'.DS.'helpers'.DS.'search.php');

class plgSearchSphinxWeblinks extends JPlugin {
    /**
     * Constructor
     *
     * @access      protected
     * @param       object  $subject The object to observe
     * @param       array   $config  An array that holds the plugin configuration
     */
    public function __construct(&$subject, $config)
    {
        parent::__construct($subject, $config);
        $this->loadLanguage();
    }
    
    function onContentSearchAreas()
    {
        static $areas = array(
            'weblinks' => 'Web links'
        );
        return $areas;
    }

    function onContentSearch( $text, $phrase='', $ordering='', $areas=null )
    {
        $plugin       =& JPluginHelper::getPlugin('search', 'sphinxWeblinks');
        $pluginParams = new JRegistry( $plugin->params );

        $pServer = $pluginParams->get( 'server', 'localhost' );
        $pPort   = (int) $pluginParams->get( 'port', 3312 );
        $pIndex  = $pluginParams->get( 'index' );
        $limit   = isset($_REQUEST['limit']) ? (int) $_REQUEST['limit'] : 50 ;
        if (0 === $limit) {
    	    $limit = 1000;
        }

        $searchText = $text;
        if (is_array( $areas )) {
            if (!array_intersect( $areas, array_keys( $this->onContentSearchAreas() ) )) {
                return array();
	        }
        }

        // clean up our search text
        $text = trim( $text );
        if ($text == '') {
            return array();
        }

        $sphinxPlugin = new SphinxSearchWeblinks($pServer, $pPort, $pIndex);
        $sphinxPlugin->setMatchMode($phrase);
        $sphinxPlugin->setOrder($ordering);
        $sphinxPlugin->setLimit(0, $limit);


        $sphinxPlugin->search($text);

        $results = $sphinxPlugin->getResults();

        // return results back to Joomla
        return $results;
    }
}